﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using Sandbox.Common;
using Sandbox.Common.Components;
using Sandbox.Common.ObjectBuilders;
using Sandbox.Definitions;
using Sandbox.Engine;
using Sandbox.Engine.Multiplayer;
using Sandbox.Game;
using Sandbox.Game.Entities;
using Sandbox.ModAPI;
using Sandbox.ModAPI.Interfaces;
using VRage.Common.Utils;
using VRageMath;
using VRage;
using VRage.ModAPI;
using VRage.ObjectBuilders;
using VRage.Components;
using VRage.Utils;


namespace SgtIgram.WhatsNewPosLights
{

    [MySessionComponentDescriptor(MyUpdateOrder.AfterSimulation)]
    public class WhatsNew : MySessionComponentBase
    {
		
		public bool init { get; private set; }
		private const string MODNAME = "PosLights";
		public const string CURRENTVERSION = "v1.0";
		private const string WHATS_NEW =
			"10.10.2015-19:00 UTC\n" +
			"[NEW]\n" +
			"+ Release\n" +
			"+ Just place it where you want it.\n" +
			"+ They need energy.\n" +
			"+ They disappear if they loose connection.\n" +
			"\n" +
			"[FIXED]\n" +
			"* nothing :D\n" +
			"\n" +
			"\n" +
			"Greetz SgtIgram\n";
		
        private const string FILE = "whatsnew.cfg";

        public void Init()
        {
			init = true;
			if (MyAPIGateway.Session.Player != null) {
				Load();
			}
        }
		
        public override void UpdateAfterSimulation()
        {
			if(!init) {
				Init();
			}
        }
		
        public void Load()
        {
            try
            {
                if(MyAPIGateway.Utilities.FileExistsInLocalStorage(FILE, typeof(WhatsNew)))
                {
                    var file = MyAPIGateway.Utilities.ReadFileInLocalStorage(FILE, typeof(WhatsNew));
                    string lastVersion = file.ReadLine();

                    file.Close();
					if(lastVersion != CURRENTVERSION) {
						DisplayNews();
					}
                } else {
					DisplayNews();
				}
            }
            catch(Exception e)
            {
				showError(e);
            }
            
        }
        
        private void DisplayNews()
        {
            try
            {
				MyAPIGateway.Utilities.ShowMissionScreen(MODNAME , CURRENTVERSION, "", WHATS_NEW, null, "Close");
				var file = MyAPIGateway.Utilities.WriteFileInLocalStorage(FILE, typeof(WhatsNew));
				file.Write(CURRENTVERSION);
				file.Flush();
				file.Close();
            }
            catch(Exception e)
            {
                showError(e);
            }
        }
        
		private void showError(Exception e) {
			try {
				MyAPIGateway.Utilities.ShowMissionScreen(MODNAME, CURRENTVERSION, "", e.ToString(), null, "Close");
			}
            catch(Exception e2)
            {
                
            }
		}
		
        public void Close()
        {
        }
    }
}